diff --git a/dirsrvtests/tests/tickets/ticket47781_test.py b/dirsrvtests/tests/tickets/ticket47781_test.py
index ed69f64..1949154 100644
--- a/dirsrvtests/tests/tickets/ticket47781_test.py
+++ b/dirsrvtests/tests/tickets/ticket47781_test.py
@@ -11,6 +11,7 @@ import logging
 import pytest
 from lib389.tasks import *
 from lib389.topologies import topology_st
+from lib389.replica import ReplicationManager
 
 from lib389._constants import (defaultProperties, DEFAULT_SUFFIX, ReplicaRole,
                                REPLICAID_MASTER_1, REPLICATION_BIND_DN, REPLICATION_BIND_PW,
@@ -28,12 +29,9 @@ def test_ticket47781(topology_st):
 
     log.info('Testing Ticket 47781 - Testing for deadlock after importing LDIF with replication data')
 
-    #
-    # Setup Replication
-    #
-    log.info('Setting up replication...')
-    topology_st.standalone.replica.enableReplication(suffix=DEFAULT_SUFFIX, role=ReplicaRole.MASTER,
-                                                     replicaId=REPLICAID_MASTER_1)
+    master = topology_st.standalone
+    repl = ReplicationManager(DEFAULT_SUFFIX)
+    repl.create_first_master(master)
 
     properties = {RA_NAME: r'meTo_$host:$port',
                   RA_BINDDN: defaultProperties[REPLICATION_BIND_DN],
@@ -41,77 +39,59 @@ def test_ticket47781(topology_st):
                   RA_METHOD: defaultProperties[REPLICATION_BIND_METHOD],
                   RA_TRANSPORT_PROT: defaultProperties[REPLICATION_TRANSPORT]}
     # The agreement should point to a server that does NOT exist (invalid port)
-    repl_agreement = topology_st.standalone.agreement.create(suffix=DEFAULT_SUFFIX,
-                                                             host=topology_st.standalone.host,
-                                                             port=5555,
-                                                             properties=properties)
+    repl_agreement = master.agreement.create(suffix=DEFAULT_SUFFIX,
+                                             host=master.host,
+                                             port=5555,
+                                             properties=properties)
 
     #
     # add two entries
     #
     log.info('Adding two entries...')
-    try:
-        topology_st.standalone.add_s(Entry(('cn=entry1,dc=example,dc=com', {
-            'objectclass': 'top person'.split(),
-            'sn': 'user',
-            'cn': 'entry1'})))
-    except ldap.LDAPError as e:
-        log.error('Failed to add entry 1: ' + e.message['desc'])
-        assert False
-
-    try:
-        topology_st.standalone.add_s(Entry(('cn=entry2,dc=example,dc=com', {
-            'objectclass': 'top person'.split(),
-            'sn': 'user',
-            'cn': 'entry2'})))
-    except ldap.LDAPError as e:
-        log.error('Failed to add entry 2: ' + e.message['desc'])
-        assert False
+
+    master.add_s(Entry(('cn=entry1,dc=example,dc=com', {
+        'objectclass': 'top person'.split(),
+        'sn': 'user',
+        'cn': 'entry1'})))
+
+    master.add_s(Entry(('cn=entry2,dc=example,dc=com', {
+        'objectclass': 'top person'.split(),
+        'sn': 'user',
+        'cn': 'entry2'})))
 
     #
     # export the replication ldif
     #
     log.info('Exporting replication ldif...')
     args = {EXPORT_REPL_INFO: True}
-    exportTask = Tasks(topology_st.standalone)
-    try:
-        exportTask.exportLDIF(DEFAULT_SUFFIX, None, "/tmp/export.ldif", args)
-    except ValueError:
-        assert False
+    exportTask = Tasks(master)
+    exportTask.exportLDIF(DEFAULT_SUFFIX, None, "/tmp/export.ldif", args)
 
     #
     # Restart the server
     #
     log.info('Restarting server...')
-    topology_st.standalone.stop()
-    topology_st.standalone.start()
+    master.stop()
+    master.start()
 
     #
     # Import the ldif
     #
     log.info('Import replication LDIF file...')
-    importTask = Tasks(topology_st.standalone)
+    importTask = Tasks(master)
     args = {TASK_WAIT: True}
-    try:
-        importTask.importLDIF(DEFAULT_SUFFIX, None, "/tmp/export.ldif", args)
-        os.remove("/tmp/export.ldif")
-    except ValueError:
-        os.remove("/tmp/export.ldif")
-        assert False
+    importTask.importLDIF(DEFAULT_SUFFIX, None, "/tmp/export.ldif", args)
+    os.remove("/tmp/export.ldif")
 
     #
     # Search for tombstones - we should not hang/timeout
     #
     log.info('Search for tombstone entries(should find one and not hang)...')
-    topology_st.standalone.set_option(ldap.OPT_NETWORK_TIMEOUT, 5)
-    topology_st.standalone.set_option(ldap.OPT_TIMEOUT, 5)
-    try:
-        entries = topology_st.standalone.search_s(DEFAULT_SUFFIX, ldap.SCOPE_SUBTREE, 'objectclass=nsTombstone')
-        if not entries:
-            log.fatal('Search failed to find any entries.')
-            assert PR_False
-    except ldap.LDAPError as e:
-        log.fatal('Search failed: ' + e.message['desc'])
+    master.set_option(ldap.OPT_NETWORK_TIMEOUT, 5)
+    master.set_option(ldap.OPT_TIMEOUT, 5)
+    entries = master.search_s(DEFAULT_SUFFIX, ldap.SCOPE_SUBTREE, 'objectclass=nsTombstone')
+    if not entries:
+        log.fatal('Search failed to find any entries.')
         assert PR_False
 
 
diff --git a/dirsrvtests/tests/tickets/ticket47787_test.py b/dirsrvtests/tests/tickets/ticket47787_test.py
index 3e10dc9..306e70d 100644
--- a/dirsrvtests/tests/tickets/ticket47787_test.py
+++ b/dirsrvtests/tests/tickets/ticket47787_test.py
@@ -20,6 +20,7 @@ import pytest
 from lib389 import Entry
 from lib389._constants import *
 from lib389.topologies import topology_m2
+from lib389.utils import *
 
 logging.getLogger(__name__).setLevel(logging.DEBUG)
 log = logging.getLogger(__name__)
@@ -187,7 +188,7 @@ def _find_tombstone(instance, base, attr, value):
     for ent in ents:
         if ent.hasAttr(attr):
             for val in ent.getValues(attr):
-                if val == value:
+                if ensure_str(val) == value:
                     instance.log.debug("tombstone found: %r" % ent)
                     return ent
     return None
@@ -198,12 +199,13 @@ def _delete_entry(instance, entry_dn, name):
 
     # delete the entry
     instance.delete_s(entry_dn)
-    assert _find_tombstone(instance, SUFFIX, 'sn', name) is not None
+    ent = _find_tombstone(instance, SUFFIX, 'sn', name)
+    assert ent is not None
 
 
 def _mod_entry(instance, entry_dn, attr, value):
     instance.log.info("\n\n######################### MOD %s (M2) ######################\n" % entry_dn)
-    mod = [(ldap.MOD_REPLACE, attr, value)]
+    mod = [(ldap.MOD_REPLACE, attr, ensure_bytes(value))]
     instance.modify_s(entry_dn, mod)
 
 
@@ -262,7 +264,7 @@ def _check_replication(topology_m2, entry_dn):
     while loop <= 10:
         attr = 'description'
         value = 'test_value_%d' % loop
-        mod = [(ldap.MOD_REPLACE, attr, value)]
+        mod = [(ldap.MOD_REPLACE, attr, ensure_bytes(value))]
         topology_m2.ms["master1"].modify_s(entry_dn, mod)
         _check_mod_received(topology_m2.ms["master2"], SUFFIX, filt, attr, value)
         loop += 1
@@ -272,7 +274,7 @@ def _check_replication(topology_m2, entry_dn):
     while loop <= 10:
         attr = 'description'
         value = 'test_value_%d' % loop
-        mod = [(ldap.MOD_REPLACE, attr, value)]
+        mod = [(ldap.MOD_REPLACE, attr, ensure_bytes(value))]
         topology_m2.ms["master2"].modify_s(entry_dn, mod)
         _check_mod_received(topology_m2.ms["master1"], SUFFIX, filt, attr, value)
         loop += 1
@@ -312,7 +314,7 @@ def test_ticket47787_init(topology_m2):
         'description': "production DIT"})))
 
     # enable replication error logging
-    mod = [(ldap.MOD_REPLACE, 'nsslapd-errorlog-level', '8192')]
+    mod = [(ldap.MOD_REPLACE, 'nsslapd-errorlog-level', b'8192')]
     topology_m2.ms["master1"].modify_s(DN_CONFIG, mod)
     topology_m2.ms["master2"].modify_s(DN_CONFIG, mod)
 
@@ -414,7 +416,7 @@ def test_ticket47787_2(topology_m2):
     assert loop <= 10
     assert ent
     assert ent.hasAttr(attr)
-    assert ent.getValue(attr) == value
+    assert ensure_str(ent.getValue(attr)) == value
 
 
 if __name__ == '__main__':
diff --git a/dirsrvtests/tests/tickets/ticket47808_test.py b/dirsrvtests/tests/tickets/ticket47808_test.py
index d2c7425..074f5e1 100644
--- a/dirsrvtests/tests/tickets/ticket47808_test.py
+++ b/dirsrvtests/tests/tickets/ticket47808_test.py
@@ -13,6 +13,7 @@ import pytest
 from lib389 import Entry
 from lib389._constants import *
 from lib389.topologies import topology_st
+from lib389.utils import *
 
 log = logging.getLogger(__name__)
 
@@ -36,8 +37,8 @@ def test_ticket47808_run(topology_st):
     topology_st.standalone.log.info("\n\n######################### SETUP ATTR UNIQ PLUGIN ######################\n")
 
     # enable attribute uniqueness plugin
-    mod = [(ldap.MOD_REPLACE, 'nsslapd-pluginEnabled', 'on'), (ldap.MOD_REPLACE, 'nsslapd-pluginarg0', 'sn'),
-           (ldap.MOD_REPLACE, 'nsslapd-pluginarg1', SUFFIX)]
+    mod = [(ldap.MOD_REPLACE, 'nsslapd-pluginEnabled', b'on'), (ldap.MOD_REPLACE, 'nsslapd-pluginarg0', b'sn'),
+           (ldap.MOD_REPLACE, 'nsslapd-pluginarg1', ensure_bytes(SUFFIX))]
     topology_st.standalone.modify_s(ATTRIBUTE_UNIQUENESS_PLUGIN, mod)
 
     topology_st.standalone.log.info("\n\n######################### ADD USER 1 ######################\n")
diff --git a/dirsrvtests/tests/tickets/ticket47819_test.py b/dirsrvtests/tests/tickets/ticket47819_test.py
index f7b5289..3955430 100644
--- a/dirsrvtests/tests/tickets/ticket47819_test.py
+++ b/dirsrvtests/tests/tickets/ticket47819_test.py
@@ -11,6 +11,7 @@ import logging
 import pytest
 from lib389.tasks import *
 from lib389.topologies import topology_st
+from lib389.replica import ReplicationManager
 
 from lib389._constants import (defaultProperties, DEFAULT_SUFFIX, ReplicaRole,
                                REPLICAID_MASTER_1, REPLICA_PRECISE_PURGING, REPLICA_PURGE_DELAY,
@@ -38,9 +39,10 @@ pytestmark = pytest.mark.skipif(ds_is_older('1.3.4'), reason="Not implemented")
     #
     # Setup Replication
     #
-    log.info('Setting up replication...')
-    topology_st.standalone.replica.enableReplication(suffix=DEFAULT_SUFFIX, role=ReplicaRole.MASTER,
-                                                     replicaId=REPLICAID_MASTER_1)
+    master = topology_st.standalone
+    repl = ReplicationManager(DEFAULT_SUFFIX)
+    repl.create_first_master(master)
+    repl.ensure_agreement(master, master)
 
     #
     # Part 1 create a tombstone entry and make sure nsTombstoneCSN is added
@@ -190,9 +192,9 @@ pytestmark = pytest.mark.skipif(ds_is_older('1.3.4'), reason="Not implemented")
     #
     log.info('Part 4:  test tombstone purging...')
 
-    args = {REPLICA_PRECISE_PURGING: 'on',
-            REPLICA_PURGE_DELAY: '5',
-            REPLICA_PURGE_INTERVAL: '5'}
+    args = {REPLICA_PRECISE_PURGING: b'on',
+            REPLICA_PURGE_DELAY: b'5',
+            REPLICA_PURGE_INTERVAL: b'5'}
     try:
         topology_st.standalone.replica.setProperties(DEFAULT_SUFFIX, None, None, args)
     except:
diff --git a/dirsrvtests/tests/tickets/ticket47823_test.py b/dirsrvtests/tests/tickets/ticket47823_test.py
index 7f4aa86..3724ace 100644
--- a/dirsrvtests/tests/tickets/ticket47823_test.py
+++ b/dirsrvtests/tests/tickets/ticket47823_test.py
@@ -201,7 +201,7 @@ def _active_container_mod(topology_st, type_config='old'):
         'cn': ACTIVE_USER_2_CN})))
 
     try:
-        topology_st.standalone.modify_s(ACTIVE_USER_2_DN, [(ldap.MOD_ADD, 'cn', ACTIVE_USER_1_CN)])
+        topology_st.standalone.modify_s(ACTIVE_USER_2_DN, [(ldap.MOD_ADD, 'cn', ensure_bytes(ACTIVE_USER_1_CN))])
     except ldap.CONSTRAINT_VIOLATION:
         # yes it is expected
         pass
@@ -209,7 +209,7 @@ def _active_container_mod(topology_st, type_config='old'):
     topology_st.standalone.log.info('Uniqueness enforced: checks MOD REPLACE entry is rejected')
     try:
         topology_st.standalone.modify_s(ACTIVE_USER_2_DN,
-                                        [(ldap.MOD_REPLACE, 'cn', [ACTIVE_USER_1_CN, ACTIVE_USER_2_CN])])
+                                        [(ldap.MOD_REPLACE, 'cn', [ensure_bytes(ACTIVE_USER_1_CN), ensure_bytes(ACTIVE_USER_2_CN)])])
     except ldap.CONSTRAINT_VIOLATION:
         # yes it is expected
         pass
@@ -316,7 +316,7 @@ def _active_stage_containers_mod(topology_st, type_config='old', across_subtrees
     try:
 
         # modify add same value
-        topology_st.standalone.modify_s(STAGE_USER_1_DN, [(ldap.MOD_ADD, 'cn', [ACTIVE_USER_2_CN])])
+        topology_st.standalone.modify_s(STAGE_USER_1_DN, [(ldap.MOD_ADD, 'cn', [ensure_bytes(ACTIVE_USER_2_CN)])])
     except ldap.CONSTRAINT_VIOLATION:
         assert across_subtrees
 
@@ -328,7 +328,7 @@ def _active_stage_containers_mod(topology_st, type_config='old', across_subtrees
     try:
         # modify replace same value
         topology_st.standalone.modify_s(STAGE_USER_1_DN,
-                                        [(ldap.MOD_REPLACE, 'cn', [STAGE_USER_2_CN, ACTIVE_USER_1_CN])])
+                                        [(ldap.MOD_REPLACE, 'cn', [ensure_bytes(STAGE_USER_2_CN), ensure_bytes(ACTIVE_USER_1_CN)])])
     except ldap.CONSTRAINT_VIOLATION:
         assert across_subtrees
 
@@ -371,7 +371,7 @@ def _active_stage_containers_modrdn(topology_st, type_config='old', across_subtr
         assert stage_ent.hasAttr('cn')
         found = False
         for value in stage_ent.getValues('cn'):
-            if value == 'dummy':
+            if ensure_str(value) == 'dummy':
                 found = True
         assert found
 
@@ -380,7 +380,7 @@ def _active_stage_containers_modrdn(topology_st, type_config='old', across_subtr
         assert active_ent.hasAttr('cn')
         found = False
         for value in stage_ent.getValues('cn'):
-            if value == 'dummy':
+            if ensure_str(value) == 'dummy':
                 found = True
         assert found
 
@@ -607,7 +607,7 @@ def test_ticket47823_invalid_config_1(topology_st):
     topology_st.standalone.getEntry(config.dn, ldap.SCOPE_BASE, "(objectclass=nsSlapdPlugin)", ALL_CONFIG_ATTRS)
 
     # Check the server did not restart
-    topology_st.standalone.modify_s(DN_CONFIG, [(ldap.MOD_REPLACE, 'nsslapd-errorlog-level', '65536')])
+    topology_st.standalone.modify_s(DN_CONFIG, [(ldap.MOD_REPLACE, 'nsslapd-errorlog-level', b'65536')])
     try:
         topology_st.standalone.restart()
         ent = topology_st.standalone.getEntry(config.dn, ldap.SCOPE_BASE, "(objectclass=nsSlapdPlugin)",
@@ -715,7 +715,7 @@ def test_ticket47823_invalid_config_3(topology_st):
     topology_st.standalone.getEntry(config.dn, ldap.SCOPE_BASE, "(objectclass=nsSlapdPlugin)", ALL_CONFIG_ATTRS)
 
     # Check the server did not restart
-    topology_st.standalone.modify_s(DN_CONFIG, [(ldap.MOD_REPLACE, 'nsslapd-errorlog-level', '65536')])
+    topology_st.standalone.modify_s(DN_CONFIG, [(ldap.MOD_REPLACE, 'nsslapd-errorlog-level', b'65536')])
     try:
         topology_st.standalone.restart()
         ent = topology_st.standalone.getEntry(config.dn, ldap.SCOPE_BASE, "(objectclass=nsSlapdPlugin)",
@@ -917,7 +917,7 @@ def test_ticket47823_invalid_config_7(topology_st):
     config = _build_config(topology_st, attr_name='cn', subtree_1="this_is dummy DN", subtree_2="an other=dummy DN",
                            type_config='new', across_subtrees=False)
 
-    topology_st.standalone.modify_s(DN_CONFIG, [(ldap.MOD_REPLACE, 'nsslapd-errorlog-level', '65536')])
+    topology_st.standalone.modify_s(DN_CONFIG, [(ldap.MOD_REPLACE, 'nsslapd-errorlog-level', b'65536')])
     # replace 'cn' uniqueness entry
     try:
         topology_st.standalone.delete_s(config.dn)
